# *************************************************************************************** #
# Fetching VM Images
# *************************************************************************************** #


# *************************************************************************************** #
# Params in @(paramName) will be replaced by vConnect. These are standard, DO NOT CHANGE
# *************************************************************************************** #
$AADSubscriptionTenantId = @(AADSubscriptionTenantId)
$AADApplicationPassword = @(AADApplicationPassword)
$AADApplicationId = @(AADApplicationId)
$Location = @(Location)

<# End Of Arguments #>

# Common Functions - Do not Remove this
. .\AzureExtensionsCommon.ps1


# *************************************************************************************** #
# Do custom processing here.
# *************************************************************************************** #

try 
{   
    VConnect-Login-AzureAccount
    if (!$?)
    {
        throw "Login failed for the provided credentials. Please contact Administrator"
    }

    $isSuccess = $true
    $vmImages = Get-AzureRmLocation | Where-Object {$_.DisplayName -eq $Location} | Get-AzureRmVMImagePublisher | Get-AzureRmVMImageOffer | Get-AzureRmVMImageSku | Get-AzureRmVMImage
     
    if($vmImages.Count -eq 0){
        $isSuccess = $false
    }       
    $resultObj = @{
        VmImages = $vmImages
        IsSuccess = $isSuccess
    }

    $result = New-Object PSObject -Property $resultObj
    return Get-ScriptResult $true 0 "Fetching VM Images Succeeded" $result
}
catch
{
    $errorMessage = "Failure fetching VM Images. Error Message: " + $_.Exception.Message
    $exception = Get-FullLastError
    return Get-ScriptErrorResult $errorMessage $exception  
}
    
